omnifiedAssembly = [[{
 Omnified Framework v. 0.1
 Written By: Matt Weber
 Copyright 2020 Bad Echo LLC

 Visit my hackpad for my information on what I do:
 https://badecho.com

 Catch my live streams on my official Twitch channel:
 https://twitch.tv/omni
}
// Global memory.
alloc(zero,8)
alloc(damageThreshold,8)
alloc(oneAndHalfX,8)
alloc(doubleX,8)

zero:
  dd 0

damageThreshold:
  dd (float)3.9
  
oneAndHalfX:
  dd (float)1.5
  
doubleX:
  dd (float)2.0

// Random number generation function.
// After r12-r14 pushes:
// [rsp+20]: initialization state address, 0 if first time
// [rsp+28]: upper bounds
// [rsp+30]: lower bounds
// return value is in EAX
alloc(generateRandomNumber,$1000)

registersymbol(generateRandomNumber)

generateRandomNumber:
  push r12
  push r13
  push r14
  mov r12,[rsp+20]
  mov r13,[rsp+28]
  mov r14,[rsp+30]
  push rbx
  push rcx
  push rdx
  push r8
  push r10
  push r11
  cmp [r12],0
  jne getRandomNumber
initializeSeed:
  call kernel32.GetTickCount
  push eax
  call msvcrt.srand
  pop eax
  mov [r12],1
getRandomNumber:
  call msvcrt.rand
  xor edx,edx
  mov ebx,r14
  mov ecx,r13
  cmp ecx,ebx
  cmovl ecx,ebx
  inc ecx
  sub ecx,ebx
  idiv ecx
  add edx,ebx
  mov eax,edx
  pop r11
  pop r10
  pop r8
  pop rdx
  pop rcx
  pop rbx
  pop r14
  pop r13
  pop r12
  ret 18
  
// Player Apocalypse System Function
// [rsp+48]: Player's coordinates (aligned at X-coord)
// [rsp+50]: Max Player Health Amount
// [rsp+58]: Player's Health Amount
// [rsp+60]: Damage Amount
// Updated damage is in EAX. 
// Updated health before damage is in EBX.
alloc(executePlayerApocalypse,$1000)
alloc(playerApocalypseRandomState,8)
alloc(logApocalypse,8)
alloc(negativeOne,8)
alloc(apocalypseResult,8)
alloc(apocalypseResultUpper,8)
alloc(apocalypseResultLower,8)
alloc(teleported,8)
alloc(teleportitisResult,8)
alloc(teleportitisResultUpper,8)
alloc(teleportitisResultLower,8)
alloc(teleportitisDivisor,8)
alloc(teleportitisShifter,8)
alloc(lastVerticalDisplacement,8)
alloc(negativeVerticalDisplacementEnabled,8)
alloc(yIsVertical,8)
alloc(teleportitisDisplacementX,8)
alloc(riskOfMurderResult,8)
alloc(riskOfMurderResultUpper,8)
alloc(riskOfMurderResultLower,8)
alloc(extraDamageX,8)
alloc(sixtyNineDamageX,8)
alloc(maxDamageToPlayer,8)
alloc(lastDamageToPlayer,8)
alloc(playerGodMode,8)

registersymbol(executePlayerApocalypse)
registersymbol(logApocalypse)
registersymbol(teleported)
registersymbol(apocalypseResult)
registersymbol(negativeVerticalDisplacementEnabled)
registersymbol(yIsVertical)
registersymbol(teleportitisDisplacementX)
registersymbol(riskOfMurderResult)
registersymbol(extraDamageX)
registersymbol(maxDamageToPlayer)
registersymbol(lastDamageToPlayer)
registersymbol(lastVerticalDisplacement)
registersymbol(playerGodMode)

executePlayerApocalypse:
  sub rsp,10
  movdqu [rsp],xmm0
  sub rsp,10
  movdqu [rsp],xmm1
  sub rsp,10
  movdqu [rsp],xmm2
  sub rsp,10
  movdqu [rsp],xmm3  
  movss xmm3,[rsp+58]
  movss xmm0,[rsp+60]
  mov rax,damageThreshold
  ucomiss xmm0,[rax]  
  jbe exitPlayerApocalypse
  cmp [playerGodMode],1
  jne applyApocalypse
  xorps xmm0,xmm0
  jmp exitPlayerApocalypse  
applyApocalypse:
  push [apocalypseResultLower]
  push [apocalypseResultUpper]
  mov rax,playerApocalypseRandomState
  push rax
  call generateRandomNumber
  mov [apocalypseResult],eax
  cmp eax,4
  jle extraDamage
  cmp eax,6
  jle teleportitis
  cmp eax,9
  jle riskOfMurder
  jmp suddenGasm
extraDamage:
  mulss xmm0,[extraDamageX]
  jmp updateEnemyDamageStats
teleportitis:
  mov [teleported],1
  mov rbx,[rsp+48]
  push [teleportitisResultLower]
  push [teleportitisResultUpper]
  mov rax,playerApocalypseRandomState
  push rax
  call generateRandomNumber
  mov [teleportitisResult],eax
  cvtsi2ss xmm1,[teleportitisResult]
  divss xmm1,[teleportitisDivisor]
  subss xmm1,[teleportitisShifter]
  mulss xmm1,[teleportitisDisplacementX]
  movss xmm2,[rbx]
  addss xmm2,xmm1
  movss [rbx],xmm2
  push [teleportitisResultLower]
  push [teleportitisResultUpper]
  mov rax,playerApocalypseRandomState
  push rax
  call generateRandomNumber
  mov [teleportitisResult],eax
  cvtsi2ss xmm1,[teleportitisResult]
  divss xmm1,[teleportitisDivisor]
  cmp [yIsVertical],1
  jne skipYSkipCheck
  cmp [negativeVerticalDisplacementEnabled],1
  jne skipNegativeVerticalYDisplacement
skipYSkipCheck:
  subss xmm1,[teleportitisShifter]
skipNegativeVerticalYDisplacement:
  mulss xmm1,[teleportitisDisplacementX]
  cmp [yIsVertical],1
  jne skipLastYVerticalDisplacement
  movss [lastVerticalDisplacement],xmm1
skipLastYVerticalDisplacement:
  movss xmm2,[rbx+4]
  addss xmm2,xmm1
  movss [rbx+4],xmm2
  push [teleportitisResultLower]
  push [teleportitisResultUpper]
  mov rax,playerApocalypseRandomState
  push rax
  call generateRandomNumber
  mov [teleportitisResult],eax
  cvtsi2ss xmm1,[teleportitisResult]
  divss xmm1,[teleportitisDivisor]
  cmp [yIsVertical],0
  jne skipZSkipCheck
  cmp [negativeVerticalDisplacementEnabled],1
  jne skipNegativeVerticalZDisplacement
skipZSkipCheck:
  subss xmm1,[teleportitisShifter]
skipNegativeVerticalZDisplacement:
  mulss xmm1,[teleportitisDisplacementX]
  cmp [yIsVertical],0
  jne skipLastZVerticalDisplacement
  movss [lastVerticalDisplacement],xmm1
skipLastZVerticalDisplacement:
  movss xmm2,[rbx+8]
  addss xmm2,xmm1
  movss [rbx+8],xmm2
  jmp updateEnemyDamageStats
riskOfMurder:
  push [riskOfMurderResultLower]
  push [riskOfMurderResultUpper]
  mov rax,playerApocalypseRandomState
  push rax
  call generateRandomNumber
  mov [riskOfMurderResult],eax
  cmp eax,3
  jle updateEnemyDamageStats
  jmp sixtyNine
sixtyNine:
  mulss xmm0,[sixtyNineDamageX]
  jmp updateEnemyDamageStats
suddenGasm:  
  movss xmm3,[rsp+50]
  xorps xmm0,xmm0
  jmp applyPlayerApocalypseExit
updateEnemyDamageStats:
  ucomiss xmm0,[maxDamageToPlayer]
  jna skipMaxEnemyDamageUpdate
  movss [maxDamageToPlayer],xmm0
skipMaxEnemyDamageUpdate:
  movss [lastDamageToPlayer],xmm0
applyPlayerApocalypseExit:
  mov [logApocalypse],1
  jmp exitPlayerApocalypse
exitPlayerApocalypse:
  xor rax,rax
  movd eax,xmm0
  movd ebx,xmm3
  movdqu xmm3,[rsp]
  add rsp,10
  movdqu xmm2,[rsp]
  add rsp,10
  movdqu xmm1,[rsp]
  add rsp,10
  movdqu xmm0,[rsp]
  add rsp,10  
  ret 20
  
playerApocalypseRandomState:
  dd 0
  
logApocalypse:
  dd 0
  
apocalypseResult:
  dd 0
  
apocalypseResultUpper:
  dd #10
  
apocalypseResultLower:
  dd 1
  
teleportitisResult:
  dd 0
  
teleportitisResultUpper:
  dd #10000
  
teleportitisResultLower:
  dd 0
  
teleportitisDivisor:
  dd (float)1000.0
  
teleportitisShifter:
  dd (float)5.0

negativeVerticalDisplacementEnabled:
  dd 1
  
yIsVertical:
  dd 1
  
teleportitisDisplacementX:
  dd (float)2.0
  
negativeOne:
  dd (float)-1.0

riskOfMurderResult:
  dd 0
  
riskOfMurderResultUpper:
  dd #5
  
riskOfMurderResultLower:
  dd 1
  
extraDamageX:
  dd (float)2.0
  
sixtyNineDamageX:
  dd (float)69.0
  
maxDamageToPlayer:
  dd 0
  
lastDamageToPlayer:
  dd 0
  
playerGodMode:
  dd 0  

  
// Enemy Apocalypse System Function
// [rsp+28]: Target Health Value
// [rsp+30]: Damage Amount
alloc(executeEnemyApocalypse,$1000)
alloc(maxDamageByPlayer,8)
alloc(lastDamageByPlayer,8)
alloc(totalDamageByPlayer,8)
alloc(logKamehameha,8)
alloc(gokuResult,8)
alloc(gokuResultUpper,8)
alloc(gokuResultLower,8)
alloc(gokuDamageX,8)
alloc(playerDamageX,8)
alloc(lastEnemyHealthValue,8)
alloc(playerCritChanceResultUpper,8)
alloc(playerCritChanceResultLower,8)
alloc(playerCritChanceResult,8)
alloc(playerCritDamageResultUpper,8)
alloc(playerCritDamageResultLower,8)
alloc(playerCritDamageResult,8)
alloc(playerCritDamageDivisor,8)
alloc(logPlayerCrit,8)
alloc(enemyApocalypseRandomState,8)

registersymbol(executeEnemyApocalypse)
registersymbol(maxDamageByPlayer)
registersymbol(lastDamageByPlayer)
registersymbol(totalDamageByPlayer)
registersymbol(logKamehameha)
registersymbol(gokuDamageX)
registersymbol(gokuResultUpper)
registersymbol(playerDamageX)
registersymbol(lastEnemyHealthValue)
registersymbol(playerCritDamageResult)
registersymbol(logPlayerCrit)

executeEnemyApocalypse:
  sub rsp,10
  movdqu [rsp],xmm0
  sub rsp,10
  movdqu [rsp],xmm1
  movss xmm0,[rsp+30]
  mov rax,damageThreshold
  ucomiss xmm0,[rax]
  jbe exitEnemyApocalypse
  movss xmm1,[rsp+28]
applyPlayerDamage:
  mulss xmm0,[playerDamageX]
  push [playerCritChanceResultLower]
  push [playerCritChanceResultUpper]
  mov rax,enemyApocalypseRandomState
  push rax
  call generateRandomNumber
  mov [playerCritChanceResult],eax
  cmp eax,25
  jg checkKamehameha
  sub rsp,10
  movdqu [rsp],xmm2
  push [playerCritDamageResultLower]
  push [playerCritDamageResultUpper]
  mov rax,enemyApocalypseRandomState
  push rax
  call generateRandomNumber
  mov [playerCritDamageResult],eax
  cvtsi2ss xmm2,[playerCritDamageResult]
  divss xmm2,[playerCritDamageDivisor]
  mulss xmm0,xmm2
  mov [logPlayerCrit],1
  movdqu xmm2,[rsp]
  add rsp,10
checkKamehameha:
  push [gokuResultLower]
  push [gokuResultUpper]
  mov rax,enemyApocalypseRandomState
  push rax
  call generateRandomNumber
  mov [gokuResult],eax
  cmp eax,#69
  jne updatePlayerDamageStats
  mov [logKamehameha],1
  mulss xmm0,[gokuDamageX]  
updatePlayerDamageStats:
  subss xmm1,xmm0
  movss [lastEnemyHealthValue],xmm1
  ucomiss xmm0,[maxDamageByPlayer]
  jna skipMaxPlayerDamageUpdate
  movss [maxDamageByPlayer],xmm0
skipMaxPlayerDamageUpdate:
  movss [lastDamageByPlayer],xmm0
  movss xmm1,xmm0
  addss xmm1,[totalDamageByPlayer]
  movss [totalDamageByPlayer],xmm1
exitEnemyApocalypse:
  xor rax,rax
  movd eax,xmm0
  movss xmm1,[rsp+28]
  movd ebx,xmm1
  movdqu xmm1,[rsp]
  add rsp,10
  movdqu xmm0,[rsp]
  add rsp,10
  ret 10

 
totalDamageByPlayer:
  dd 0

maxDamageByPlayer:
  dd 0
  
lastDamageByPlayer:
  dd 0  

logKamehameha:
  dd 0

gokuResult:
  dd 0
  
gokuResultUpper:
  dd #1000
  
gokuResultLower:
  dd 0
  
gokuDamageX:
  dd (float)10000.0
  
playerDamageX:
  dd (float)1.0
  
lastEnemyHealthValue:
  dd 0
  
playerCritChanceResult:
  dd 0
  
playerCritChanceResultUpper:
  dd #800
  
playerCritChanceResultLower:
  dd 0
  
playerCritDamageResult:
  dd 0
  
playerCritDamageResultUpper:
  dd #50
  
playerCritDamageResultLower:
  dd #20
  
playerCritDamageDivisor:
  dd (float)10.0
  
logPlayerCrit:
  dd 0
  
enemyApocalypseRandomState:
  dd 0
  
// Predator System Functions
alloc(enemySpeedX,8)
alloc(aggroDistance,8)
alloc(threatDistance,8)
alloc(speedNormalizationDivisor,8)
alloc(skipBoostY,8)
alloc(skipBoostZ,8)

registersymbol(enemySpeedX)
registersymbol(skipBoostY)
registersymbol(skipBoostZ)
registersymbol(threatDistance)
registersymbol(aggroDistance)

enemySpeedX:
  dd (float)2.0

aggroDistance:
  dd (float)10.0

threatDistance:
  dd (float)2.5

speedNormalizationDivisor:
  dd (float)3.0

skipBoostY:
  dd 1
  
skipBoostZ:
  dd 0


// Determines the distance between the player and another
// creature.
// [rsp+28]: Enemy Z Coordinate
// [rsp+30]: Enemy Y Coordinate
// [rsp+34]: Enemy X Coordinate
// [rsp+38]: Player Z Coordinate
// [rsp+40]: Player Y Coordinate
// [rsp+44]: Player X Coordinate
// Distance is in EAX
alloc(findCoordinateDistance,$1000)

registersymbol(findCoordinateDistance)

findCoordinateDistance:
  sub rsp,10
  movdqu [rsp],xmm0
  sub rsp,10
  movdqu [rsp],xmm1
  movups xmm0,[rsp+28]
  movups xmm1,[rsp+38]
  subps xmm0,xmm1
  mulps xmm0,xmm0
  movdqu xmm1,xmm0
  shufps xmm1,xmm0,0xB
  addss xmm0,xmm1
  shufps xmm1,xmm1,0x1
  addss xmm0,xmm1
  sqrtss xmm0,xmm0
  movd eax,xmm0
  movdqu xmm1,[rsp]
  add rsp,10
  movdqu xmm0,[rsp]
  add rsp,10
  ret 20

// Calculates the scaled base speed.
// [rsp+28]: Enemy Depth Scale
// [rsp+30]: Enemy Height Scale
// [rsp+34]: Enemy Width Scale
// Scaled speed is in EAX.
alloc(calculateScaledSpeed,$1000)
alloc(averageScaleDivisor,8)
alloc(averageScaleX,8)
alloc(scaledShifter,8)
alloc(scaledSpeedWhenNegative,8)

registersymbol(calculateScaledSpeed)

calculateScaledSpeed:
  sub rsp,10
  movdqu [rsp],xmm0
  sub rsp,10
  movdqu [rsp],xmm1
  // Find average of the three scales.
  movss xmm0,[rsp+28]
  movss xmm1,[rsp+30]
  addss xmm0,xmm1
  movss xmm1,[rsp+34]
  addss xmm0,xmm1
  divss xmm0,[averageScaleDivisor]
  // Plug the scale average into the scaled speed formula.
  mulss xmm0,[averageScaleX]
  addss xmm0,[scaledShifter]
  mulss xmm0,[enemySpeedX]
  divss xmm0,[speedNormalizationDivisor]
  movss xmm1,xmm0
  movd eax,xmm1
  shr eax,1F
  test eax,eax
  je commitScaledSpeed
  movss xmm0,[scaledSpeedWhenNegative]
commitScaledSpeed:
  movd eax,xmm0
  movdqu xmm1,[rsp]
  add rsp,10
  movdqu xmm0,[rsp]
  add rsp,10
  ret 10


averageScaleDivisor:
  dd (float)3.0

averageScaleX:
  dd (float)-1.67

scaledShifter:
  dd (float)4.675

scaledSpeedWhenNegative:
  dd (float)0.5

// Determines if enemy is moving towards the player.
// [rsp+38]: Change to Enemy's Z
// [rsp+40]: Change to Enemy's Y
// [rsp+44]: Change to Enemy's X
// [rsp+48]: Enemy's Z Coordinate
// [rsp+50]: Enemy's Y Coordinate
// [rsp+54]: Enemy's X Coordinate
// [rsp+58]: Player's Z Coordinate
// [rsp+60]: Player's Y Coordinate
// [rsp+64]: Player's X Coordinate
// EAX is 1 if enemy is moving towards player, otherwise 0.
alloc(isMovingTowards,$1000)

registersymbol(isMovingTowards)

isMovingTowards:
  sub rsp,10
  movdqu [rsp],xmm0
  sub rsp,10
  movdqu [rsp],xmm1
  sub rsp,10
  movdqu [rsp],xmm2
  movups xmm0,[rsp+58]
  movups xmm1,[rsp+48]
  subps xmm0,xmm1
  mulps xmm0,xmm0
  // xmm0: (zp-ze)^2 | 0 | (xp-xe)^2 | (yp-ye)^2
  movups xmm1,xmm0
  shufps xmm1,xmm0,0x87
  // xmm1: (yp-ye)^2 | 0 | (zp-ze)^2 | (xp-xe)^2 
  cmpps xmm0,xmm1,6
  sub rsp,10
  movups [rsp],xmm0  
isYGreaterThanX:
  mov eax,[rsp+C]
  test eax,eax
  jne isZGreaterThanY
  je isXGreaterThanZ
isZGreaterThanY:
  mov eax,[rsp]
  test eax,eax
  jne isZMovingTowards
  je isYMovingTowards
isXGreaterThanZ:
  mov eax,[rsp+8]
  test eax,eax
  jne isXMovingTowards
  je isZMovingTowards
isYMovingTowards:
  add rsp,10
  xor rax,rax
  movups xmm0,[rsp+38]
  mulps xmm0,xmm0
  sub rsp,10
  movups [rsp],xmm0
  movss xmm0,[rsp+C]
  // Is the change in Y greater than the change in X?
  ucomiss xmm0,[rsp+8]
  jb primaryChangeTooSmall
  // Is the change in Y greater than the change in Z?
  ucomiss xmm0,[rsp]
  jb primaryChangeTooSmall  
  add rsp,10
  movss xmm0,[rsp+60]
  subss xmm0,[rsp+50]
  movss xmm1,[rsp+40]
  jmp isChangeMovingTowards
isXMovingTowards:
  add rsp,10
  xor rax,rax
  movups xmm0,[rsp+38]
  mulps xmm0,xmm0
  sub rsp,10
  movups [rsp],xmm0
  movss xmm0,[rsp+8]
  // Is the change in X greater than the change in Y?
  ucomiss xmm0,[rsp+C]
  jb primaryChangeTooSmall
  // Is the change in X greater than the change in Z?
  ucomiss xmm0,[rsp]
  jb primaryChangeTooSmall
  add rsp,10
  movss xmm0,[rsp+64]
  subss xmm0,[rsp+54]
  movss xmm1,[rsp+44]
  jmp isChangeMovingTowards
isZMovingTowards:
  add rsp,10
  xor rax,rax
  movups xmm0,[rsp+38]
  mulps xmm0,xmm0
  sub rsp,10
  movups [rsp],xmm0
  movss xmm0,[rsp]
  // Is the change in Z greater than the change in Y?
  ucomiss xmm0,[rsp+C]
  jb primaryChangeTooSmall
  // Is the change in Z greater than the change in X?
  ucomiss xmm0,[rsp+8]
  jb primaryChangeTooSmall
  add rsp,10
  movss xmm0,[rsp+58]
  subss xmm0,[rsp+48]
  movss xmm1,[rsp+38]
isChangeMovingTowards:
  movd eax,xmm0
  shr eax,1F
  test eax,eax
  jne isChangeNegative
  movd eax,xmm1
  shr eax,1F
  test eax,eax
  je confirmMovingTowards
  xor rax,rax
  jmp isMovingTowardsExit
isChangeNegative:
  movd eax,xmm1
  shr eax,1F
  test eax,eax
  jne confirmMovingTowards
  xor rax,rax
  jmp isMovingTowardsExit
confirmMovingTowards:
  mov eax,1
  jmp isMovingTowardsExit
primaryChangeTooSmall:
  add rsp,10
isMovingTowardsExit:
  movdqu xmm2,[rsp]
  add rsp,10
  movdqu xmm1,[rsp]
  add rsp,10
  movdqu xmm0,[rsp]
  add rsp,10
  ret 30


// Main Predator System Function
// [rsp+98]: Change to Enemy's Z
// [rsp+A0]: Change to Enemy's Y
// [rsp+A4]: Change to Enemy's X
// [rsp+A8]: Enemy Depth Scale
// [rsp+B0]: Enemy Width Scale
// [rsp+B4]: Enemy Height Scale
// [rsp+B8]: Enemy's Z Coordinate
// [rsp+C0]: Enemy's Y Coordinate
// [rsp+C4]: Enemy's X Coordinate
// [rsp+C8]: Player's Z Coordinate
// [rsp+D0]: Player's Y Coordinate
// [rsp+D4]: Player's X Coordinate
// EAX has updated change to enemy X, EBX has updated
// change to enemy Y, ECX has updated change to enemy Z
alloc(executePredator,$1000)
alloc(indifferenceDistanceX,8)
alloc(defaultSpeedX,8)
alloc(positiveLimit,8)
alloc(negativeLimit,8)
alloc(positiveLimitCorrection,8)
alloc(negativeLimitCorrection,8)


registersymbol(executePredator)

executePredator:
  sub rsp,10
  movdqu [rsp],xmm0
  sub rsp,10
  movdqu [rsp],xmm1
  sub rsp,10
  movdqu [rsp],xmm2
  sub rsp,10
  movdqu [rsp],xmm3
  sub rsp,10
  movdqu [rsp],xmm4
  sub rsp,10
  movdqu [rsp],xmm5
  sub rsp,10
  movdqu [rsp],xmm6
  sub rsp,10
  movdqu [rsp],xmm7
  sub rsp,10
  movdqu [rsp],xmm8
  xorps xmm8,xmm8
  movss xmm8,[defaultSpeedX]
  movups xmm0,[rsp+C8]
  movups xmm1,[rsp+B8]
  movups xmm2,[rsp+A8]
  movups xmm3,[rsp+98]
  sub rsp,10
  movdqu [rsp],xmm2
  call calculateScaledSpeed
  movd xmm4,eax
  sub rsp,10
  movdqu [rsp],xmm0
  sub rsp,10
  movdqu [rsp],xmm1
  call findCoordinateDistance
  movd xmm5,eax
  ucomiss xmm5,[aggroDistance]
  jbe areaOfAggro
  movss xmm7,[aggroDistance]
  mulss xmm7,[indifferenceDistanceX]
  ucomiss xmm5,xmm7
  jb areaOfSketchiness
areaOfIndifference:
  movss xmm8,xmm4
  jmp executePredatorExit
areaOfSketchiness:
  movss xmm8,xmm4
  sub rsp,10
  movdqu [rsp],xmm0
  sub rsp,10
  movdqu [rsp],xmm1
  sub rsp,10
  movdqu [rsp],xmm3
  call isMovingTowards
  cmp eax,1
  jne executePredatorExit
  mulss xmm8,[doubleX]
  jmp executePredatorExit
areaOfAggro:
  ucomiss xmm5,[threatDistance]
  jbe executePredatorExit
  movss xmm8,[defaultSpeedX]
  //mulss xmm8,[doubleX]
  sub rsp,10
  movdqu [rsp],xmm0
  sub rsp,10
  movdqu [rsp],xmm1
  sub rsp,10
  movdqu [rsp],xmm3
  call isMovingTowards
  cmp eax,0
  je executePredatorExit
  movss xmm8,xmm4
  mulss xmm8,[doubleX]
  mulss xmm8,[doubleX]
executePredatorExit:
  cmp [skipBoostZ],1
  je commitZChange
  mulss xmm3,xmm8
commitZChange:
  movd ecx,xmm3
  shufps xmm3,xmm3,0x87
  cmp [skipBoostY],1
  je commitYChange
  mulss xmm3,xmm8
commitYChange:
  movd ebx,xmm3
  shufps xmm3,xmm3,0x87
  mulss xmm3,xmm8
  movd eax,xmm3
  push rax
  shr eax,1F
  test eax,eax
  pop rax
  jne isXLessThanNegativeLimit
  movd xmm2,eax
  ucomiss xmm2,[positiveLimit]
  jbe isYPastLimit
  mov eax,[positiveLimitCorrection]
  jmp isYPastLimit
isXLessThanNegativeLimit:
  movd xmm2,eax
  ucomiss xmm2,[negativeLimit]
  ja isYPastLimit
  mov eax,[negativeLimitCorrection]
isYPastLimit:
  push rbx
  shr ebx,1F  
  test ebx,ebx
  pop rbx
  jne isYLessThanNegativeLimit
  movd xmm2,ebx
  ucomiss xmm2,[positiveLimit]
  jbe isZPastLimit
  mov ebx,[positiveLimitCorrection]
  jmp isZPastLimit
isYLessThanNegativeLimit:
  movd xmm2,ebx
  ucomiss xmm2,[negativeLimit]
  ja isZPastLimit
  mov ebx,[negativeLimitCorrection]
isZPastLimit:
  push rcx
  shr ecx,1F
  test ecx,ecx
  pop rcx
  jne isZLessThanNegativeLimit
  movd xmm2,ecx
  ucomiss xmm2,[positiveLimit]
  jbe executePredatorCleanup
  mov ecx,[positiveLimitCorrection]
  jmp executePredatorCleanup
isZLessThanNegativeLimit:
  movd xmm2,ecx
  ucomiss xmm2,[negativeLimit]
  ja executePredatorCleanup
  mov ecx,[zero]
executePredatorCleanup:
  movdqu xmm8,[rsp]
  add rsp,10
  movdqu xmm7,[rsp]
  add rsp,10
  movdqu xmm6,[rsp]
  add rsp,10
  movdqu xmm5,[rsp]
  add rsp,10
  movdqu xmm4,[rsp]
  add rsp,10
  movdqu xmm3,[rsp]
  add rsp,10
  movdqu xmm2,[rsp]
  add rsp,10
  movdqu xmm1,[rsp]
  add rsp,10
  movdqu xmm0,[rsp]
  add rsp,10
  ret 40

defaultSpeedX:
  dd (float)1.0

indifferenceDistanceX:
  dd (float)2.0

positiveLimit:
  dd (float)15.0

negativeLimit:
  dd (float)-15.0

positiveLimitCorrection:
  dd (float)0

negativeLimitCorrection:
  dd (float)0
]]

omnifiedDisableAssembly = [[
// Cleanup of global memory

dealloc(zero)
dealloc(damageThreshold)
dealloc(oneAndHalfX)
dealloc(doubleX)

// Cleanup of generateRandomNumber
unregistersymbol(generateRandomNumber)

dealloc(generateRandomNumber)

// Cleanup of Player Apocalypse System Function
unregistersymbol(logApocalypse)
unregistersymbol(teleported)
unregistersymbol(apocalypseResult)
unregistersymbol(riskOfMurderResult)
unregistersymbol(yIsVertical)
unregistersymbol(lastVerticalDisplacement)
unregistersymbol(negativeVerticalDisplacementEnabled)
unregistersymbol(teleportitisDisplacementX)
unregistersymbol(extraDamageX)
unregistersymbol(maxDamageToPlayer)
unregistersymbol(playerGodMode)
unregistersymbol(lastDamageToPlayer)
unregistersymbol(executePlayerApocalypse)

dealloc(playerApocalypseRandomState)
dealloc(logApocalypse)
dealloc(teleported)
dealloc(apocalypseResult)
dealloc(apocalypseResultUpper)
dealloc(apocalypseResultLower)
dealloc(negativeOne)
dealloc(teleportitisResult)
dealloc(teleportitisResultUpper)
dealloc(teleportitisResultLower)
dealloc(teleportitisDivisor)
dealloc(teleportitisShifter)
dealloc(lastVerticalDisplacement)
dealloc(yIsVertical)
dealloc(negativeVerticalDisplacementEnabled)
dealloc(teleportitisDisplacementX)
dealloc(riskOfMurderResult)
dealloc(riskOfMurderResultUpper)
dealloc(riskOfMurderResultLower)
dealloc(extraDamageX)
dealloc(sixtyNineDamageX)
dealloc(maxDamageToPlayer)
dealloc(lastDamageToPlayer)
dealloc(executePlayerApocalypse)
dealloc(playerGodMode)

// Cleanup of Enemy Apocalypse System Function
unregistersymbol(maxDamageByPlayer)
unregistersymbol(lastDamageByPlayer)
unregistersymbol(totalDamageByPlayer)
unregistersymbol(logKamehameha)
unregistersymbol(gokuDamageX)
unregistersymbol(gokuResultUpper)
unregistersymbol(playerDamageX)
unregistersymbol(lastEnemyHealthValue)
unregistersymbol(playerCritDamageResult)
unregistersymbol(logPlayerCrit)
unregistersymbol(executeEnemyApocalypse)

dealloc(maxDamageByPlayer)
dealloc(lastDamageByPlayer)
dealloc(totalDamageByPlayer)
dealloc(logKamehameha)
dealloc(gokuResult)
dealloc(gokuResultUpper)
dealloc(gokuResultLower)
dealloc(gokuDamageX)
dealloc(playerDamageX)
dealloc(lastEnemyHealthValue)
dealloc(playerCritChanceResultUpper)
dealloc(playerCritChanceResultLower)
dealloc(playerCritChanceResult)
dealloc(playerCritDamageResultUpper)
dealloc(playerCritDamageResultLower)
dealloc(playerCritDamageResult)
dealloc(playerCritDamageDivisor)
dealloc(logPlayerCrit)
dealloc(enemyApocalypseRandomState)
dealloc(executeEnemyApocalypse)

// Cleanup of findCoordinateDistance
unregistersymbol(findCoordinateDistance)

dealloc(findCoordinateDistance)

// Cleanup of calculateScaledSpeed
unregistersymbol(calculateScaledSpeed)

dealloc(averageScaleDivisor)
dealloc(averageScaleX)
dealloc(scaledShifter)
dealloc(scaledSpeedWhenNegative)
dealloc(calculateScaledSpeed)

// Cleanup of isMovingTowards
unregistersymbol(isMovingTowards)

dealloc(isMovingTowards)


// Cleanup of Predator System Function
unregistersymbol(executePredator)
unregistersymbol(enemySpeedX)
unregistersymbol(skipBoostY)
unregistersymbol(skipBoostZ)
unregistersymbol(threatDistance)
unregistersymbol(aggroDistance)

dealloc(enemySpeedX)
dealloc(skipBoostY)
dealloc(skipBoostZ)
dealloc(aggroDistance)
dealloc(threatDistance)
dealloc(indifferenceDistanceX)
dealloc(speedNormalizationDivisor)
dealloc(defaultSpeedX)
dealloc(positiveLimit)
dealloc(negativeLimit)
dealloc(positiveLimitCorrection)
dealloc(negativeLimitCorrection)
dealloc(executePredator)
]]

registered = false
disableInfo = nil

function registerOmnification()
	if registered == false then
		registered, disableInfo = autoAssemble(omnifiedAssembly)
		
		if registered == false then
			print("Failed to register Omnification.")
		end
	end
end

function unregisterOmnification()
	if registered == true and disableInfo ~= nil then
		local disabled = autoAssemble(omnifiedDisableAssembly, disableInfo)
		
		if disabled == false then
			print("Failed to uninject.")
		else 
			registered = false
		end		
	else 
		print("Nothing to unregister.")
	end
end